-------------------------------监测发电机


local mapcell = {150,150}
local cellx = mapcell[1]*300
local celly = mapcell[2]*300

local function cahouseEveryHours()
    for y=0,4 do
        for u=0,4 do

            local square=getCell():getGridSquare(cellx+1+60*y,celly+6+60*u,2)
            if square then
                local objects=square:getObjects()
                if objects then
                    for i=1,objects:size() do
                        if instanceof(objects:get(i-1), "IsoGenerator") then
                            objects:get(i-1):setFuel(99999)
                            objects:get(i-1):setCondition(99999)
                        end
                    end
                end
            end
        end
    end
end

Events.EveryHours.Add(cahouseEveryHours)


---------------------------------------------------------------------------
----------------------------------房间代码

local carhousenumpos={}
carhousenumpos[1]={0,0}
carhousenumpos[2]={1,0}
carhousenumpos[3]={2,0}
carhousenumpos[4]={3,0}
carhousenumpos[5]={4,0}
carhousenumpos[6]={0,1}
carhousenumpos[7]={1,1}
carhousenumpos[8]={2,1}
carhousenumpos[9]={3,1}
carhousenumpos[10]={4,1}
carhousenumpos[11]={0,2}
carhousenumpos[12]={1,2}
carhousenumpos[13]={2,2}
carhousenumpos[14]={3,2}
carhousenumpos[15]={4,2}
carhousenumpos[16]={0,3}
carhousenumpos[17]={1,3}
carhousenumpos[18]={2,3}
carhousenumpos[19]={3,3}
carhousenumpos[20]={4,3}
carhousenumpos[21]={0,4}
carhousenumpos[22]={1,4}
carhousenumpos[23]={2,4}
carhousenumpos[24]={3,4}
carhousenumpos[25]={4,4}

local housedel
local housedelY
----------------------------------------生成发电机
local function carhouseLoadGridsquare(square)
    if square:getX()==cellx+1+60*housedel and square:getY()==celly+6+60*housedelY and square:getZ() ==2 then
        local NewGenerator
        local objects = square:getObjects()
        -- if square:getObjects():size()<=1 then return end
        if square:getObjects():size()>1 and instanceof(square:getObjects():get(1), "IsoGenerator") then
            -- print("havegenerator")
            NewGenerator = square:getObjects():get(1)
            NewGenerator:setConnected(true)
            NewGenerator:setFuel(99999)
            NewGenerator:setCondition(99999)
            NewGenerator:setActivated(true)
            NewGenerator:setSurroundingElectricity()
        else
            NewGenerator = IsoGenerator.new(nil,getCell(),square)
            NewGenerator:setConnected(true)
            NewGenerator:setFuel(99999)
            NewGenerator:setCondition(99999)
            NewGenerator:setActivated(true)
            NewGenerator:setSurroundingElectricity()
        end
        Events.LoadGridsquare.Remove(carhouseLoadGridsquare)
    end
end

local function entercarhouse(this,button,player,vehicle)
    if button.internal == "YES" then

        if isClient() then
            sendClientCommand("MH_II_Entercarhouse","true",{vehicle:getId(),player:getOnlineID()})
            -- print("MH_MKII_Entercarhouse1")
            
        else
            if vehicle:getModData().carishousenum ==nil then

                if getGameTime():getModData().carhousenum==nil then
                    getGameTime():getModData().carhousenum=0
        
                    
                end
                getGameTime():getModData().carhousenum=getGameTime():getModData().carhousenum+1
                vehicle:getModData().carishousenum=getGameTime():getModData().carhousenum
    
            end
            local detxy=carhousenumpos[vehicle:getModData().carishousenum]
            if detxy==nil then return end
            housedel=detxy[1]
            housedelY=detxy[2]
    
            getGameTime():getModData().carhousepos={true,{player:getX(),player:getY(),player:getZ()},housedel,housedelY}
            vehicle:exit(player)
            player:setX(cellx+1+60*housedel)
            player:setY(celly+7+60*housedelY)
            player:setZ(0)
            player:setLx(cellx+1+60*housedel)
            player:setLy(celly+7+60*housedelY)
            player:setLz(0)
            Events.LoadGridsquare.Add(carhouseLoadGridsquare)
            
        end
        
    end
end



---------------------------------------------------------------------------上车顶

local playerisoncarroof = false
local vehicleroof
local playerangle
local playerpos

local vehiclesize = {1.2,4}
local vwide = 3.16
local vheight = 10
local height = 1.3
local playerspeed = 0.025
local playerposfirst
local playerpospre = {}
local carpospre = nil

local function getfunctionab(table1,table2)

    local a,b
    local c = table1[1]-table2[1]
    if c~= 0 then
        a = (table1[2]-table2[2])/c
        b = table1[2]-a*table1[1]
        return a,b
        
    else 
        return false,false
    end
end

local function check_OnPlayerUpdate(player)
    if player:getCurrentSquare()==nil then
        player:setZ(0)
        
    end
    Events.OnPlayerUpdate.Remove(check_OnPlayerUpdate)
end

Events.OnPlayerUpdate.Add(check_OnPlayerUpdate)

local function createfloor(x,y,z)
    local namez = "invisible_01_0"
    -- local namez = "floors_interior_tilesandwood_01_0"
    for i=-2,2 do
        for k=-2,2 do

            if math.abs(i) ==2 or math.abs(k)==2 then
                local squarez = getCell():getGridSquare(x+i,y+k,z)
                if squarez then
                    local removeitem
                    local objs = squarez:getObjects()
                    for z=0, objs:size() - 1 do
                        if objs:get(z):getSprite() ~= nil and objs:get(z):getSprite():getName() == namez then
                            removeitem=objs:get(z)
                            break
                            

                            
                        end
                    end
                    if removeitem then
                        squarez:RemoveTileObjectErosionNoRecalc(removeitem)
                        
                    end
                    
                end
                
            else
                local squarez = getCell():getOrCreateGridSquare(x+i,y+k,z)
                local tileAlreadyOnSquare = false
                local objs = squarez:getObjects()
                for z=0, objs:size() - 1 do
                    if objs:get(z):getSprite() ~= nil and objs:get(z):getSprite():getName() == namez then
                        tileAlreadyOnSquare = true
                    end
                end
                if not tileAlreadyOnSquare then
                    local objectz = IsoObject.new(squarez, namez, "", false)
                    squarez:AddTileObject(objectz)
                    -- local props = ISMoveableSpriteProps.new(IsoObject.new(squarez, namez):getSprite())
                    -- props:placeMoveableInternal(squarez, InventoryItemFactory.CreateItem("Base.Plank"), namez)
                end
            end
        end
    end 
end

local function remove_floor(x,y,z)
    local namez = "invisible_01_0"
    -- local namez = "floors_interior_tilesandwood_01_0"
    for i=-1,1 do
        for k=-1,1 do

            local squarez = getCell():getGridSquare(x+i,y+k,z)
            if squarez then
                local removeitem = {}
                local objs = squarez:getObjects()
                for z=0, objs:size() - 1 do
                    if objs:get(z):getSprite() ~= nil and objs:get(z):getSprite():getName() == namez then

                        table.insert(removeitem,objs:get(z))
                    end
                end

                for k,v in pairs(removeitem) do
                    squarez:RemoveTileObjectErosionNoRecalc(v)
                
                end
                
            end
        end
    end 
end

---上车顶核心代码
local function onroof_OnPlayerUpdate(player)
    if not (vehicleroof and playerisoncarroof and playerangle and playerpos)  then

        
        Events.OnPlayerUpdate.Remove(onroof_OnPlayerUpdate)
        return 
    end
    local driver = vehicleroof:getDriver()
    if driver then
        playerangle = driver:getForwardDirection():getDirection()
    end

    local vx = vehicleroof:getX()
    local vy = vehicleroof:getY()
    local vz = vehicleroof:getZ()

    playerpos = {player:getX()-2.3,player:getY()-2.3,1.3}

    -----1-----2------
    -----4-----3------
    local vx1 = vx + vehiclesize[2]*math.cos(playerangle) + vehiclesize[1]*math.cos(playerangle+math.pi/2)
    local vy1 = vy + vehiclesize[2]*math.sin(playerangle) + vehiclesize[1]*math.sin(playerangle+math.pi/2)

    local vx2 = vx + vehiclesize[2]*1.4*math.cos(playerangle+math.pi) + vehiclesize[1]*math.cos(playerangle+math.pi/2)
    local vy2 = vy + vehiclesize[2]*1.4*math.sin(playerangle+math.pi) + vehiclesize[1]*math.sin(playerangle+math.pi/2)

    local vx3 = vx + vehiclesize[2]*1.4*math.cos(playerangle+math.pi) + vehiclesize[1]*math.cos(playerangle-math.pi/2)
    local vy3 = vy + vehiclesize[2]*1.4*math.sin(playerangle+math.pi) + vehiclesize[1]*math.sin(playerangle-math.pi/2)

    local vx4 = vx + vehiclesize[2]*math.cos(playerangle) + vehiclesize[1]*math.cos(playerangle-math.pi/2)
    local vy4 = vy + vehiclesize[2]*math.sin(playerangle) + vehiclesize[1]*math.sin(playerangle-math.pi/2)

    local pos1 = {vx1,vy1}
    local pos2 = {vx2,vy2}
    local pos3 = {vx3,vy3}
    local pos4 = {vx4,vy4}

    local postable = {pos1,pos2,pos3,pos4}

    --排序
    local maxy = {0,0}
    local maxx = {0,0}
    local miny = {0,99999}
    local minx = {99999,0}
    for i=1,#postable do

        if postable[i][2] >= maxy[2] then
            maxy = {postable[i][1],postable[i][2]}
        end

        if postable[i][1] >= maxx[1] then
            maxx = {postable[i][1],postable[i][2]}
        end

        if postable[i][2] <= miny[2] then
            miny = {postable[i][1],postable[i][2]}
        end

        if postable[i][1] <= minx[1] then
            minx = {postable[i][1],postable[i][2]}
        end
    end

    --左斜上1  右斜下2

    local a1,b1 = getfunctionab(maxy,minx)
    local a2,b2 = getfunctionab(maxy,maxx)
    local a3,b3 = getfunctionab(maxx,miny)
    local a4,b4 = getfunctionab(minx,miny)

    if isKeyDown(Keyboard.KEY_UP) then
        

        -- player:setX(preplayer[1])
        -- player:setY(preplayer[2])

        -- print("asdasd")
        -- player:setZ(0)
        vehicleroof:enter(3, player)
        -- ISVehicleMenu.onEnter(player, vehicleroof, 3)
        -- ISTimedActionQueue.add(ISEnterVehicle:new(player, vehicleroof, 3))
        vehicleroof:setCharacterPosition(player, 3, "inside")
	    vehicleroof:transmitCharacterPosition(3, "inside")
	    vehicleroof:playPassengerAnim(3, "idle")
        carpospre = nil
        triggerEvent("OnSwitchVehicleSeat", player)
        remove_floor(player:getX(),player:getY(),player:getZ())
        Events.OnPlayerUpdate.Remove(onroof_OnPlayerUpdate)
        Events.OnPlayerUpdate.Remove(onroof_OnPlayerUpdate)
        player:getModData().MH_II_isoncar = {false,{vx,vy,vz}}
        return
    end

    local ismove = false


    if not a1 or not b1 then
        if playerpos[2]<=maxy[2] and playerpos[2]<=miny[2] and playerpos[1] <= maxx[1] and playerpos[1] >= minx[1] then
            ismove = true
        else
            ismove = false
        end
    else
        if playerpos[2]<=playerpos[1]*a1 +b1 and playerpos[2]<=playerpos[1]*a2 +b2 and playerpos[2]>=playerpos[1]*a3 +b3 and playerpos[2]>=playerpos[1]*a4 +b4 then
            ismove = true 
        else
            ismove = false
        end
    
        
    end

    createfloor(player:getX(),player:getY(),2)

    
    if ismove then

        playerpospre = {player:getX(),player:getY(),player:getX()}
        if carpospre then
            if carpospre[1]~=vx or carpospre[2] ~=vy then
                player:setX(player:getX()+vx-carpospre[1])
                player:setY(player:getY()+vy-carpospre[2])
            end
        end
    else

        if isClient() and carpospre and (carpospre[1]~=vx or carpospre[2] ~=vy) then
            player:setX(vx+2.3)
            player:setY(vy+2.3)
            
        else
            player:setX(playerpospre[1])
            player:setY(playerpospre[2])
            -- player:setZ(playerpospre[3])
            
        end
        
        
        
    end

    

    if player:getZ()~=2 then
        player:setZ(2)
        
    end

    carpospre = {vx,vy,vz}

end
-- local vehiclelocal_
-----------------------------------弹道
local function itemremove(worlditem)
    if worlditem==nil then return end
    -- if true then return end
    worlditem:getWorldItem():getSquare():transmitRemoveItemFromSquare(worlditem:getWorldItem())
    worlditem:getWorldItem():removeFromSquare()
end
local function mathfloor(number)
    return number-math.floor(number)
end

local function checkiswallordoor(square)
    if square ==nil then return end
    local vehiclez = square:getVehicleContainer()
    if vehiclez then
        -- getSoundManager():PlayWorldSoundWav( "BreakBarricadeMetal",square, 0.5, 2, 0.5, true);
        -- getPlayer():getEmitter():playSound("HitBarricadeMetal")
        vehiclez:getEmitter():playSound("HitBarricadeMetal")
        vehiclez:HitByVehicle(vehiclez, 5)
        return true
        
    end
    local objects = square:getObjects()
    if objects then
        for i=1,objects:size() do
            local sprite = objects:get(i-1):getSprite()
            if sprite  then
                local Properties = sprite:getProperties()
                if Properties then
                    if Properties:Is(IsoFlagType.WallN) or Properties:Is(IsoFlagType.doorN) or Properties:Is(IsoFlagType.WallW) or Properties:Is(IsoFlagType.doorW) then
                        -- getSoundManager():PlayWorldSoundWav( "BreakObject",square, 0.5, 2, 0.5, true);
                        getPlayer():getEmitter():playSound("BreakObject")
                        return true
                    end
                end   
            end
        end
    end
end

local guntowercore = {}
local isleftbuttondown = false

local function MH_OnLeftMouseDown()
    isleftbuttondown = true
end
local function MH_OnLeftMouseUp(x, y)
	isleftbuttondown = false
end

Events.OnObjectLeftMouseButtonUp.Add(MH_OnLeftMouseUp)
Events.OnObjectLeftMouseButtonDown.Add(MH_OnLeftMouseDown)

local function OnPlayerisoncarupdate(player)
    local playermod = player:getModData().MH_II_isoncar
    local square = getCell():getOrCreateGridSquare(playermod[2][1],playermod[2][2],playermod[2][3])
    if square==nil then return end
    local vehicle=square:getVehicleContainer()
    if vehicle~=nil and  vehicle:getScript():getFullName() == "Base.ArmoredMH_MkII"then
        vehicle:enter(3, player)
        vehicle:setCharacterPosition(player, 3, "inside")
	    vehicle:transmitCharacterPosition(3, "inside")
	    vehicle:playPassengerAnim(3, "idle")
        triggerEvent("OnSwitchVehicleSeat", player)
        Events.OnPlayerUpdate.Remove(OnPlayerisoncarupdate)
    end
    player:getModData().MH_II_isoncar = {false,{}}
end


local function OnCreatePlayer(playerIndex, player)
    if player:getModData().MH_II_isoncar then
        if player:getModData().MH_II_isoncar[1] then
            Events.OnPlayerUpdate.Add(OnPlayerisoncarupdate)
        end
        
    end
	-- Your code here
end

Events.OnCreatePlayer.Add(OnCreatePlayer)

local function onroofpre_OnPlayerUpdate(ticknumber)
    local player = getPlayer()
    if player==nil then return end
    local vehicle = player:getVehicle()
    if vehicle == nil then
        Events.OnTick.Remove(onroofpre_OnPlayerUpdate)
        for k,v in pairs(guntowercore) do
            itemremove(v[1])
        end
        return
    end

    local gunangle = nil

    for k,v in pairs(guntowercore) do

        local avenfps = getAverageFPS()
        if avenfps >=60 then
            avenfps=60   
        end
        guntowercore[k][6] = guntowercore[k][6]*60/avenfps
        if guntowercore[k][1] then
            itemremove(guntowercore[k][1])
        end

        if guntowercore[k][2] then

            guntowercore[k][4][1] = guntowercore[k][4][1]+guntowercore[k][6]*guntowercore[k][3][1]
            guntowercore[k][4][2] = guntowercore[k][4][2]+guntowercore[k][6]*guntowercore[k][3][2]
            guntowercore[k][4][3] = guntowercore[k][4][3] - guntowercore[k][6]*guntowercore[k][9]
            guntowercore[k][2] = getWorld():getCell():getOrCreateGridSquare(guntowercore[k][4][1],guntowercore[k][4][2],guntowercore[k][4][3])
            
            if guntowercore[k][4][3] <= 0 then

                local isshoopsquare
                if guntowercore[k][11] then
                    isshoopsquare=guntowercore[k][11]
                    
                else
                    isshoopsquare = getCell():getOrCreateGridSquare(guntowercore[k][4][1],guntowercore[k][4][2],0)
                end

                local zombielistz ={}
                for u=-1,1 do
                    
                    for p=-1 ,1 do

                        local currentsqu = getCell():getOrCreateGridSquare(isshoopsquare:getX()+u,isshoopsquare:getY()+p,0)
                        

                        

                        if currentsqu then
                            local movingObjects = currentsqu:getMovingObjects()

                            local zombiesize = movingObjects:size()
                            if zombiesize>=3 then zombiesize=3 end
                            for akl=1, zombiesize do
                                local zombiez = movingObjects:get(akl-1)
                                if zombiez   then
                                    if zombiez:isZombie() then
                                        -- zombielistz[zombiez] = 1

                                        table.insert(zombielistz,zombiez)


                                        
                                    end
                                end
                            end
                            
                            
                        end
                    end
                    
                


                end
                for index_,item_ in pairs(zombielistz) do
                    for inaz = 1,2 do 
                        local zombiesp = zombielistz[ZombRand(#zombielistz)+1]
                        
                        if zombiesp then
                            zombiesp:addBlood(1000)
                            zombiesp:Kill(player)

                            
                        end
                    end
                
                end


                itemremove(guntowercore[k][1])
                guntowercore[k]=nil
                return
                -- print("1nill")
            elseif checkiswallordoor(guntowercore[k][2]) then
                itemremove(guntowercore[k][1])
                guntowercore[k]=nil
                return
        
            else
                
                guntowercore[k][1]=guntowercore[k][2]:AddWorldInventoryItem(guntowercore[k][7],mathfloor(guntowercore[k][4][1]), mathfloor(guntowercore[k][4][2]) ,mathfloor(guntowercore[k][4][3]))
                guntowercore[k][1]:setWorldZRotation(guntowercore[k][5])
            end
            
            
        end

        -- local isfirstsquare = getWorld():getCell():getOrCreateGridSquare(guntowercore[k][4][1],guntowercore[k][4][2],0)
    end
    

    local vx = vehicle:getX()
    local vy = vehicle:getY()
    local vz = vehicle:getZ()

    if isKeyDown(Keyboard.KEY_DOWN) then
        

        if vz>0.5 then return end

        playerpos = {vx,vy,height}
        -- playerposfirst = {vx,vy,height}
        playerangle=player:getForwardDirection():getDirection()
        vehicle:exit(player)
        vehicleroof = vehicle
        playerisoncarroof = true
        -- getCell():getOrCreateGridSquare()
        createfloor(vx+2.3,vy+2.3,2)
        player:setX(vx+2.3)
        player:setY(vy+2.3)
        player:setZ(2)

        player:getModData().MH_II_isoncar = {true,{vx,vy,vz}}




        
        Events.OnTick.Remove(onroofpre_OnPlayerUpdate)
        Events.OnPlayerUpdate.Add(onroof_OnPlayerUpdate)
    end


    local part = vehicle:getPartById("MH_MkII_guntower")
    if not (part:getCondition()>0 and part:getInventoryItem() ) then return end

    local a , b = math.modf(ticknumber/ 7)
    -- print("GUN!")

   
    if b==0  then



       
        

            
        if player:getInventory():contains("mh_50_bullet") and isleftbuttondown then


            if ZombRand(10)>3 then
                player:getInventory():Remove("mh_50_bullet")
                
            end
            

            local playerX = player:getX()
            local playerY = player:getY()
            local playerZ = player:getZ()
            local mouseX, mouseY = ISCoordConversion.ToWorld(getMouseXScaled(), getMouseYScaled(), 0);
            local targetMouseX = mouseX+1.5;
            local targetMouseY = mouseY+1.5;
            local direction = (math.atan2(targetMouseY-playerY, targetMouseX-playerX));
    
            local feetDirection = player:getDir():toAngle();
            if feetDirection < 2 then
                feetDirection = -(feetDirection+(math.pi*0.5))
            else
                feetDirection = (math.pi*2)-(feetDirection+(math.pi*0.5))
            end
            if math.cos(direction - feetDirection) < math.cos(67.5) then
                if math.sin(direction - feetDirection) < 0 then
                    direction = feetDirection - (math.pi/4)
                else
                    direction = feetDirection + (math.pi/4)
                end
            end --Avoids an aiming angle pointing behind the person
    
            local aimingAngle = 10
            local aimingDistance = 50
    
            local playerOffsetX = playerX - math.floor(playerX);
            local playerOffsetY = playerY - math.floor(playerY);
    
            local mWorldZ = playerZ;
    
            --playerZ = player:getZ();
    
            -- local cell = getWorld():getCell();
            local squaremouse = getCell():getOrCreateGridSquare(math.floor(targetMouseX), math.floor(targetMouseY), 0);
            -- if playerZ > 0 then
            --     for i=math.floor(playerZ), 1, -1 do
            --         square = cell:getOrCreateGridSquare(math.floor(mouseX+1.5)+(i*3), math.floor(mouseY+1.5)+(i*3), i);
            --         if square and square:isSolidFloor() then
            --             targetMouseX = mouseX+1.5+i;
            --             targetMouseY = mouseY+1.5+i;
            --             break
            --         end
            --     end
            -- end
            -- if square then
            --     local movingObjects = square:getMovingObjects();
            --     if (movingObjects ~= nil) then
            --         for ii=0, movingObjects:size()-1 do
            --             local zombie = movingObjects:get(ii)
            --             if string.find(tostring(zombie),"IsoFallingClothing") == nil then
            --                 if zombie:isZombie() then
            --                     if player:CanSee(zombie) then
            --                         CDDA_ShowZombieName[CDDA_GetZombieID(zombie)] = {zombie, 255}
            --                     end
            --                 end
            --             end
            --         end
            --     end
            -- end

            

            local dirc = player:getForwardDirection():getDirection()+ZombRandFloat(-math.pi/40,math.pi/40)

            -- local dirc = player:getForwardDirection():getDirection()
            local deltX=math.cos(dirc)
            local deltY=math.sin(dirc)
        
            local offx = vx +deltX*4
            local offy = vy +deltY*4
            local offz = 1.3

        

            local k_ = offz/(((targetMouseX-offx)^2 +(targetMouseY-offy)^2)^0.5)



            dirc = dirc*360/(2*math.pi)
        
        
            local tablez = 
            {
                nil,                                       --1物品obj
                player:getCurrentSquare(),                 --2方格obj
                {deltX,deltY},                             --3向量
                {offx, offy, offz},                        --4偏移量
                dirc,                                      --5方向
                0.35,                                      --6弹道速度
                "Base.revolversfx1",                       --7弹道名称
                1,                                         --8尺寸
                k_,                                         --9斜率
                {vx,vy,vz},                                 --10原始坐标
                squaremouse                                  ---11squaremouse

            }
            table.insert(guntowercore,tablez)
            if not vehicle:getEmitter():isPlaying("MH_MkIIguntower") then
                vehicle:getEmitter():playSound("MH_MkIIguntower")
            end
            
        else
            vehicle:getEmitter():stopSoundByName("MH_MkIIguntower")
        end
    end
end


--------------------------------调整座位触发
local function MH_MkII_OnSwitchVehicleSeat(player)
	local vehicle = player:getVehicle()
    if vehicle:getScript():getFullName() ~= "Base.ArmoredMH_MkII" then return end
    local seatnumber = vehicle:getSeat(player)
    if seatnumber==2 then
        local MH_MkIIenter = ISModalDialog:new(0,0, 250, 150, getText("IGUI_jinruchefang"), true, nil, entercarhouse, 0,player,vehicle)
        MH_MkIIenter:initialise()
        MH_MkIIenter:addToUIManager()
        Events.OnTick.Remove(onroofpre_OnPlayerUpdate)
        -- Events.OnTick.Remove(MK_MkII_railg.ontick)
    elseif seatnumber==3 then
        Events.OnTick.Add(onroofpre_OnPlayerUpdate)
        -- Events.OnTick.Remove(MK_MkII_railg.ontick)
    -- elseif seatnumber==10 then
    --     MK_MkII_railg.firtdic = player:getForwardDirection():getDirection()
    --     Events.OnTick.Add(MK_MkII_railg.ontick)
    --     Events.OnTick.Remove(onroofpre_OnPlayerUpdate)
        
    else
        -- Events.OnTick.Remove(MK_MkII_railg.ontick)
        Events.OnTick.Remove(onroofpre_OnPlayerUpdate)
    end

end

Events.OnSwitchVehicleSeat.Add(MH_MkII_OnSwitchVehicleSeat)




---------------------------------------------------------------------------菜单

local function OnPlayerEntercar(player)
    local square = player:getCurrentSquare()
    if square==nil then return end
    local vehicle=square:getVehicleContainer()
    if vehicle~=nil then
        vehicle:enter(2, player)
        Events.OnPlayerUpdate.Remove(OnPlayerEntercar)
    end
end
local function carhouseexitf(worldObjects,player,zsquare)

    if isClient() then
        sendClientCommand("MH_II_carhouseExit","true",{player:getOnlineID()})
        
    else
        if luautils.walkAdj(player,zsquare) then
            ISTimedActionQueue.add(MH_MkIIwalk:new(player,getGameTime():getModData().carhousepos[2][1], getGameTime():getModData().carhousepos[2][2], getGameTime():getModData().carhousepos[2][3]))
        end
        

    end

    
end

local function carhouseexit(player, context, worldObjects)
    player=getPlayer(player)

    if isClient() then
        local square=player:getCurrentSquare()
        local _x=square:getX()
        local _y=square:getY()
        local _z=square:getZ()
        if _x>=cellx and _x<=cellx+300 and _y>=celly and _y<=celly+300 and _z==0 then
            context:addOption(getText("IGUI_exitcarhouse"), worldObjects,carhouseexitf,player)
        end
        
    else
        if getGameTime():getModData().carhousepos==nil then return end
        local square=player:getCurrentSquare()
        local _x=square:getX()
        local _y=square:getY()
        local _z=square:getZ()
        local carhouseinfo = getGameTime():getModData().carhousepos[3]
        local carhouseinfoy =getGameTime():getModData().carhousepos[4]
        -- square=getCell():getGridSquare(cellx+3+(carhouseinfo)*60,celly+9,0)
        
    
        local __x = cellx+carhouseinfo*60
        if _x>=__x and _x<=__x+3 and _y>=celly+carhouseinfoy*60 and _y<=celly+8+carhouseinfoy*60 and _z==0 then
            square=getCell():getGridSquare(__x+3,celly+8+carhouseinfoy*60,0)
    
            context:addOption(getText("IGUI_exitcarhouse"), worldObjects,carhouseexitf,player,square)
            
        end
        

    end
    

    
		
	
end
Events.OnFillWorldObjectContextMenu.Add(carhouseexit)




------------------------------客户端

if not isClient() then return end
local ismovecarid

local function client_OnPlayerEntercar(player)
    local square = player:getCurrentSquare()
    if square==nil then return end
    local vehicle=square:getVehicleContainer()
    if vehicle~=nil then
        vehicle:enter(2, player)
        Events.OnPlayerUpdate.Remove(client_OnPlayerEntercar)   
    end

    
end
local function client_OnPlayerEntercar2(player)
    local vehicle = getVehicleById(ismovecarid)
    if  vehicle then
        vehicle:enter(2, player)
        Events.OnPlayerUpdate.Remove(client_OnPlayerEntercar2)   
        
    end
end

local function Chouse_OnServerCommand(module, command, arguments)
    local player=getPlayer()
    if module=="MH_MKII_Entercarhouse"then

        -- print("MH_MKII_Entercarhouse0")

        housedel=carhousenumpos[arguments[1]][1]
        housedelY=carhousenumpos[arguments[1]][2]
        local vehicle = getVehicleById(arguments[2])
        vehicle:exit(player)
        player:setX(cellx+1+60*housedel)
        player:setY(celly+7+60*housedelY)
        player:setZ(0)
        player:setLx(cellx+1+60*housedel)
        player:setLy(celly+7+60*housedelY)
        player:setLz(0)
        Events.LoadGridsquare.Add(carhouseLoadGridsquare)
    elseif module=="MH_MKII_carhouseExit" then
        if arguments[4]~=false then
            ismovecarid=arguments[4][2]
            player:setX(arguments[1])
            player:setY(arguments[2])
            player:setZ(0)
            player:setLx(arguments[1])
            player:setLy(arguments[2])
            player:setLz(0)

            Events.OnPlayerUpdate.Add(client_OnPlayerEntercar2)
        else
            player:setX(arguments[1])
            player:setY(arguments[2])
            player:setZ(0)
            player:setLx(arguments[1])
            player:setLy(arguments[2])
            player:setLz(0)
            Events.OnPlayerUpdate.Add(client_OnPlayerEntercar)
        end

    elseif module=="MHpartcondition" then
        local vehiclezb = getVehicleById(arguments[1])
        if vehiclezb then
            local partzb = vehiclezb:getPartById(command)
            if partzb then
                partzb:setCondition(arguments[2])
                
            end
            

        end
		


    elseif module=="MH_MkII_railgun" then
        local vehicleza = getVehicleById(arguments[1])
		if vehicleza then
			vehicleza:getModData().MH_MkII_railgundic = arguments[2]
            local partrailgun = vehicleza:getPartById("MH_MkII_railgun")

            if  partrailgun and partrailgun:getInventoryItem() then
                for i=1,24 do
                    if i~= vehicleza:getModData().MH_MkII_railgundic then
                        partrailgun:setModelVisible("MH_MkII_railgun"..tostring(i), false)  
                    else
                        partrailgun:setModelVisible("MH_MkII_railgun"..tostring(i), true)  
                    end      
                end
            else
                partrailgun:setAllModelsVisible(false)
            end
		end

        



    end


end


Events.OnServerCommand.Add(Chouse_OnServerCommand)