require "TimedActions/ISBaseTimedAction"

ISMH_railgunaction = ISBaseTimedAction:derive("ISMH_railgunaction");              
function ISMH_railgunaction:isValid()                        
	return true
end

function ISMH_railgunaction:itemremove(worlditem)
    if worlditem==nil then return end
    -- if true then return end
    worlditem:getWorldItem():getSquare():transmitRemoveItemFromSquare(worlditem:getWorldItem())
    worlditem:getWorldItem():removeFromSquare()
end

function ISMH_railgunaction:boom(squarez)
	for i=-5,5 do
		for k=-5,5 do


			-- print(squarez)
			local square=getCell():getGridSquare(squarez:getX()+i,squarez:getY()+k,0)

			if square then
				local corenumber = i^2+k^2
				if ZombRand(10)<=8 then
					local zombie = square:getZombie()
					if zombie then
						zombie:Kill(self.character)
					
					end
					
				end

				local vehclez = square:getVehicleContainer()
				

				if vehclez then
					local vehicleznme = vehclez:getScript():getFullName()
                    -- print(string.contains("..Burnt", "burnt"))
					if vehclez and (string.contains(vehicleznme, "Burnt") or string.contains(vehicleznme, "Smashed") ) then
						if isClient() then
							sendClientCommand(self.character, "vehicle", "remove", { vehicle = vehclez:getId() })
						else
							vehclez:permanentlyRemove()
						end
					end
					
				end
				

				
			end
	
			
		   
			
		end
	
	
	end
    
end




function ISMH_railgunaction:update() 
	
	-- print("update")
	-- self.timerz = self.timerz+1
	if self.item==nil and not self.vehicle:getEmitter():isPlaying("railgun_fight") then
		-- print("Boom")
		self.vehicle:getEmitter():playSound("railgun_boom")
		-- stop()
		-- self:forceComplete()

		self.square = getWorld():getCell():getOrCreateGridSquare(self.character:getX()+self.distance*self.delx,self.character:getY()+self.distance*self.dely,0)

		-- print(self.character:getX()+self.distance*self.delx)
		-- print(self.character:getY()+self.distance*self.dely)
		-- print()
		if self.square ==nil then
			self:forceComplete()
			
		else
			self.item = self.square:AddWorldInventoryItem("Base.theMH_MkII_SFX"..tostring(self.itemnum),0.5, 0.5, 0)
			self:boom(self.square)
		end
		
	end

	if self.item then
		self:itemremove(self.item)

		if self.itemnum <12 then
			self.itemnum = self.itemnum+1
			self.item = self.square:AddWorldInventoryItem("Base.theMH_MkII_SFX"..tostring(self.itemnum),0.5, 0.5, 0)
		else
			self:forceComplete()
		end

		
		



	end
	-- print(self.timerz)
end

function ISMH_railgunaction:start()
	self.vehicle:getEmitter():playSound("railgun_fight")
	-- vehiclez:getEmitter():playSound("HitBarricadeMetal")



    -- self:setActionAnim("Forage")                     
end

function ISMH_railgunaction:stop()                             
    ISBaseTimedAction.stop(self);
end

function ISMH_railgunaction:perform()
	ISBaseTimedAction.perform(self)
	-- print("complate")





	



end

function ISMH_railgunaction:new(vehicle,distance,delx,dely,character)     
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.maxTime = 300;
	o.timer = 300/5;
	o.tick = 0;
	o.timerz = 0
	o.character = character;
	o.vehicle = vehicle
	o.itemlist = {}
	o.square = nil
	o.item = nil
	o.itemnum = 1
	o.delx=delx
	o.dely = dely
	o.distance = distance
	return o;
end
